﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class addedAfterSolution : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "AfterSolutionFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    AfterSolutionId = table.Column<int>(nullable: false),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(nullable: true),
                    IsDisplayed = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TemplateFileId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AfterSolutionFiles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_AfterSolutionFiles_TemplateFiles_TemplateFileId",
                        column: x => x.TemplateFileId,
                        principalTable: "TemplateFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "AfterSolutions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AfterSolutions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_AfterSolutions_AfterSolutionFiles_MainFileId",
                        column: x => x.MainFileId,
                        principalTable: "AfterSolutionFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_AfterSolutions_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestWithAfterSolutionAsTestResults",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    AfterSolutionId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithAfterSolutionAsTestResults", x => new { x.CustomTestId, x.AfterSolutionId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithAfterSolutionAsTestResults_AfterSolutions_AfterSolutionId",
                        column: x => x.AfterSolutionId,
                        principalTable: "AfterSolutions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTestWithAfterSolutionAsTestResults_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestWithAfterSolutionAsTestResults",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    AfterSolutionId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestWithAfterSolutionAsTestResults", x => new { x.TestId, x.AfterSolutionId });
                    table.ForeignKey(
                        name: "FK_TestWithAfterSolutionAsTestResults_AfterSolutions_AfterSolutionId",
                        column: x => x.AfterSolutionId,
                        principalTable: "AfterSolutions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TestWithAfterSolutionAsTestResults_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutions_MainFileId",
                table: "AfterSolutions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "AfterSolutions",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutionFiles_AfterSolutionId",
                table: "AfterSolutionFiles",
                column: "AfterSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutionFiles_TemplateFileId",
                table: "AfterSolutionFiles",
                column: "TemplateFileId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithAfterSolutionAsTestResults_AfterSolutionId",
                table: "CustomTestWithAfterSolutionAsTestResults",
                column: "AfterSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithAfterSolutionAsTestResults_CustomTestId",
                table: "CustomTestWithAfterSolutionAsTestResults",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithAfterSolutionAsTestResults_AfterSolutionId",
                table: "TestWithAfterSolutionAsTestResults",
                column: "AfterSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithAfterSolutionAsTestResults_TestId",
                table: "TestWithAfterSolutionAsTestResults",
                column: "TestId");

            migrationBuilder.AddForeignKey(
                name: "FK_AfterSolutionFiles_AfterSolutions_AfterSolutionId",
                table: "AfterSolutionFiles",
                column: "AfterSolutionId",
                principalTable: "AfterSolutions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AfterSolutions_AfterSolutionFiles_MainFileId",
                table: "AfterSolutions");

            migrationBuilder.DropTable(
                name: "CustomTestWithAfterSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "TestWithAfterSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "AfterSolutionFiles");

            migrationBuilder.DropTable(
                name: "AfterSolutions");
        }
    }
}
