﻿using ClientServer.Models.Exercises;
using ClientServer.Models.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using ClientServer.Db;

namespace ClientServer.Models.CustomProjects
{
    /// <summary>
    /// why? if we want to open an exercise (e.g. because time used up) as an custom project (like a sandbox)
    /// then we have a nearly 1:1 mapping between an exercise and a custom project
    /// 
    /// this is also helpful if one day students can suggest exercises (--> 1:1 mapping)
    /// </summary>
    public class CustomProjectDescription : IDescription
    {
        public int Id { get; set; }
        /// <summary>
        /// the content
        /// </summary>
        [MaxLength(YapexDbContext.DescriptionContentMaxStringLength)]
        public string Content { get; set; }

        /// <summary>
        /// the assets for the description e.g. images
        /// </summary>
        public List<Asset> Assets { get; set; }

        /// <summary>
        /// the assets for the description e.g. images
        /// </summary>
        public List<CustomProjectDescriptionWithFileAsAssetReference> AssetReferences { get; set; }

        /// <summary>
        /// fk
        /// </summary>
        public int CustomProjectId { get; set; }
        public CustomProject CustomProject { get; set; }
    }
}
